/***************************************************************
 * Name:      PE5004_GUI.cpp
 * Purpose:   Code for Application Frame
 * Author:    jvc ()
 * Created:   2009-05-13
 * Copyright: jvc ()
 * License:
 **************************************************************/


#include "5004_GUI.h"

#include <iostream>
#include <fstream>
#include <wx/wx.h>
#include "windows.h"
#include "version.h"
#include "wxDialogs.h"
#include "wx/config.h"
#include "wx/confbase.h"
#include "wx/fileconf.h"
#include "wx/msw/regconf.h"


using namespace std;

bargraph::bargraph(wxFrame *frame, int iCol)
         : frame_bargraph(frame)
         {
             SetIcon(wxICON(APPICON));
             SetTitle(wxString::Format("Bar Graph Column %d", iCol));
         }
void bargraph::OnClose (wxCloseEvent& event) {
    Hide();
}

void bargraph::Update_all(int iCol, int *iRow, int Value_ADC[11][11])
{
    for(int i =0; i< *iRow; i++) bar[i]->SetValue(Value_ADC[i][iCol]);
}

bargraph::~bargraph()
{
}

valuetable::valuetable (wxFrame *frame)
           : frame_valuetable(frame)
           {
               SetIcon(wxICON(APPICON));
           }

void valuetable::OnClose (wxCloseEvent& event) {
    Hide();
}

void valuetable::Update_all(int *iCol,int *iRow, int Value_ADC[11][11])
{
    for(int row =0; row< *iRow; row++)for(int col =0; col< *iCol; col++)
            tf_ADC_[(row*10)+col+1]->SetValue(wxString::Format("%i", Value_ADC[row][col]));
}

valuetable::~valuetable()
{
}

valuegrid::valuegrid (wxFrame *frame)
           : frame_valuegrid(frame)
           {
               SetIcon(wxICON(APPICON));
           }

void valuegrid::OnClose (wxCloseEvent& event) {
    Hide();
}

void valuegrid::Update_all(int *iCol,int *iRow, int Value_ADC[11][11])
{
    wxClientDC cdc(this);
    wxDC &dc = cdc ;
    wxBufferedDC bdc(&dc);
    bdc.SetPen( wxPen( wxT("yellow"), 1, wxSOLID) );
    bdc.SetBackground(wxBrush(wxColour(0,0,0)));
    bdc.Clear();


    for(int row =0; row< *iRow; row++)
        for(int col =0; col< *iCol; col++)
        {

         if (col<(*iCol-1)) bdc.DrawLine( 20+40*col+row*20, 500-(20*row+Value_ADC[*iRow-1-row][col]/4), 20+40*(col+1)+row*20, 500-(20*row+Value_ADC[*iRow-1-row][col+1]/4) );
         if (row<(*iRow-1)) bdc.DrawLine( 20+40*col+row*20, 500-(20*row+Value_ADC[*iRow-1-row][col]/4), 20+40*(col)+(row+1)*20, 500-(20*(row+1)+Value_ADC[*iRow-1-row-1][col]/4) );

        }
}

valuegrid::~valuegrid()
{
}

touch::touch (wxFrame *frame)
           : frame_touch(frame)
           {
               SetIcon(wxICON(APPICON));
               ballx=400; bally=300; ballmy=0; ballmx=14;score1=0;score2=0;ytouch1=300;ytouch2=300;
           }

void touch::OnClose (wxCloseEvent& event) {
    Hide();
}

#define ds 3
void touch::Update_all(int *iCol,int *iRow, int Value_ADC[11][11], bool boxmode_game, bool boxmode_oled)
{
    touch_count=0;
    touch_det1=0;
    touch_det2=0;
    midval=0;
    wxClientDC cdc(this);
    wxDC &dc = cdc ;
    wxBufferedDC bdc(&dc);
    bdc.SetPen( wxPen( wxT("yellow"), 5, wxSOLID) );
    bdc.SetBrush(wxBrush(wxColour(255,255,0)));
    bdc.SetTextForeground(wxColour(255,255,0));
    bdc.SetBackground(wxBrush(wxColour(0,0,0)));
    bdc.Clear();
    if (boxmode_game == true){
        weight=0;
        btouch=false;
        vec_y=0;
        for(int row =0; row< *iRow; row++)
        {
            for(int col =0; col< 4; col++)
            {
                if (Value_ADC[row][col]>0){
                    btouch=true;
                    vec_y += (row * Value_ADC[row][col]); // wxLogDebug("vec %i", vec_y);
                    weight += Value_ADC[row][col]; //wxLogDebug("weight %i", weight);
                }
            }
        }
        if (btouch == true){
            vec_y *= 82; //wxLogDebug("vec60 %i", vec_y);
            ytouch1=vec_y / weight + 40;// wxLogDebug("touch %i", ytouch1);
        }

        weight=0;
        btouch=false;
        vec_y=0;
        for(int row =0; row< *iRow; row++)
        {
            for(int col =4; col< *iCol; col++)
            {
                if (Value_ADC[row][col]>0){
                    btouch=true;
                    vec_y += (row * Value_ADC[row][col]);
                    weight += Value_ADC[row][col];
                }
            }
        }
        if (btouch == true){
            vec_y *= 82;
            ytouch2=vec_y / weight + 40;
        }
        bdc.DrawLine(30,ytouch1-50,30,ytouch1+50);
        if (ballx < 35) if (ballmx<0) if (ballx>(29+ballmx)) if (ytouch1-50 < bally) {
            if (bally < ytouch1 +50) Beep(1000, 10);
            if (bally < ytouch1 -20) {ballmx =-ballmx+ds*dy;ballmy-=ds;}
            else if (bally < ytouch1 +20) {ballmx *=-1;}
            else if (bally < ytouch1 +50) {ballmx =-ballmx-ds*dy;ballmy+=ds;}
        }

        bdc.DrawLine(770,ytouch2-50,770,ytouch2+50);
        if (ballx > 765) if (ballmx>0) if (ballx<(771+ballmx)) if (ytouch2-50 < bally){
            if (bally < ytouch2 +50) Beep(300, 10);
            if (bally < ytouch2 -20) {ballmx =-ballmx-ds*dy;ballmy-=ds;}
            else if (bally < ytouch2 +20) ballmx *=-1;
            else if (bally < ytouch2 +50) {ballmx =-ballmx+ds*dy;ballmy+=ds;}
        }


        bally+=ballmy; if (bally<0 or bally>560) ballmy *=-1;
        ballx+=ballmx;

        if (ballx<5) {ballmx*=-1;score2++;Beep(2000,200);Sleep(1000);}//Beep(500,100);Beep(400,100);Beep(300,100);Beep(1,5000);}
        if (ballx>795) {ballmx*=-1;score1++;Beep(2000,200);Sleep(1000);}//Beep(500,100);Beep(400,100);Beep(300,100);Beep(1,5000);}

        bdc.SetBrush(wxBrush(wxColour(255,0,0)));
        bdc.DrawCircle( ballx, bally, 10);
        if (ballmy>0) dy=1; else dy=0; if (ballmy<0) dy=-1;
        bdc.DrawText(wxString::Format("%i : %i", score1, score2), 400, 1);

    }
    else{
        ballx=400; bally=300; ballmy=0; ballmx=18;score1=0;score2=0;ytouch1=300;ytouch2=300;
        for(int col =0; col< *iCol; col++) my[0][col+1]=Value_ADC[0][col];
        for(int row =0; row< *iRow; row++){
            mx[row+1][0]=Value_ADC[row][0];
            for(int col =0; col< *iCol; col++) {

                    mx[row+1][col+1]=(Value_ADC[row][col+1]-Value_ADC[row][col]);
                    my[row+1][col+1]=(Value_ADC[row+1][col]-Value_ADC[row][col]);

                    if (mx[row+1][col+1]<0) if (my[row+1][col+1]<0) if (mx[row+1][col]>0) if (my[row][col+1]>0){
                        touch_count++;
                        midval+=Value_ADC[row][col];
                        touchval[touch_count]=Value_ADC[row][col];
                       // wxLogDebug("zeugx %d",(mx[row+1][col]-mx[row+1][col+1]));
                       // wxLogDebug("zeugy %d",(my[row][col+1]-my[row+1][col+1]));
                        xtouch[touch_count]=(col*100+((mx[row+1][col]+mx[row+1][col+1])*50/(mx[row+1][col]-mx[row+1][col+1])));
                        ytouch[touch_count]=(row*84+((my[row][col+1]+my[row+1][col+1])*42/(my[row][col+1]-my[row+1][col+1])));
                        if (Value_ADC[row][col] > weight) weight=Value_ADC[row][col];
                    }
            }
        }
        weight /=3;
        for(int row =1; row<=touch_count; row++)
            if (touchval[row] > weight) if (touchval[row]>(25))
            {
                  bdc.DrawCircle( xtouch[row], ytouch[row], 10);
            }
    }

}

touch::~touch()
{
    wxLogDebug("aus");
}

calibpanel::calibpanel(wxFrame *frame)
    : frame_calib(frame)
{

    SetIcon(wxICON(APPICON));
    Selected_PE5004 = PE5004_FIRST;

    wxString strCaption;
    strCaption = (wxString) APPNAME + " " + APPVERS;
    SetTitle(strCaption);
    SetStatusBarPane(wxID_ANY);

    sign =0;
    for(int i = 0; i < 10; i++) pbar[i] = new bargraph(this, i);
    pval = new valuetable(this);
    pgrid = new valuegrid(this);
    pTimer = new wxTimer(this);
    ptouch = new touch(this);
    usbDev = new CUSBDevice();
    usbDev->togglecurrent = 1;
    Connect(wxEVT_TIMER, wxCommandEventHandler(calibpanel::OnTimer));
    Update_all();
 	}

void calibpanel::OnHistory(wxCommandEvent &event) {
    CHistoryDialog *dialog = new CHistoryDialog(this);
    dialog->ShowModal();
    delete dialog;
}

void calibpanel::OnExit(wxCommandEvent &event) {
    Destroy();
}

void calibpanel::OnAbout(wxCommandEvent &event) {
    CAboutDialog *dialog = new CAboutDialog(this);
    dialog->ShowModal();
    delete dialog;
}

void calibpanel::OnTimer(wxCommandEvent &event)
{
    int HELPVAL;
    int i;
    int c;
    int r;
    Update_all();

    wxLogDebug("start");
    pUSB_write[0] = 0;
    pUSB_write[1] = usbDev->togglecurrent;
    pUSB_write[2] = Value_WaitCOL;
    pUSB_write[3] = Value_WaitROW;
    pUSB_write[4] = (Value_PWRI<<4)|(Value_PWRP<<2)|(Value_PWRS);
    pUSB_write[5] = Value_SINF;
    pUSB_write[6] = Value_SINA;
    pUSB_write[7] = (Value_GCO<<4)|Value_DACREF;
    pUSB_write[8] = Value_PCO;
    pUSB_write[9] = (Value_PCO>>8);
    //caution: GUI ROW correspond to PE5004 COL and GUI COL correspond to PE5004 ROW
    if (Selected_PE5004 == PE5004_FIRST ){
        if(cb_boxmode1->GetValue() == true) { //check if OLED selected
        pUSB_write[10] = 0xdd; //the EVABoard firmware dedect this as OLED selected
        pUSB_write[13] = 0x12;
        //pUSB_write[13] = ((Value_ROWSTART)<<4)|(10-Value_COLEND);
        }
        else{
        pUSB_write[10] = (Value_ROWEND<<4)|(9-Value_COLSTART);
        pUSB_write[13] = ((Value_ROWSTART)<<4)|(10-Value_COLEND);
        }
    }
    else {
        pUSB_write[10] = ((Value_COLEND-1)<<4)|(Value_ROWEND-1);
        pUSB_write[13] = ((Value_COLSTART-1)<<4)|(Value_ROWSTART-1);
    }
    pUSB_write[11] = Selected_PE5004;



    //write init values
    usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
    if (mode){
         Sleep(100);
         //dummy reads
         if (Selected_PE5004 == PE5004_FIRST ){ //col and row are switched and inverted chip-pins to orientation
                usbDev-> Read(USB_read, USB_BYTELENGTH);}
         else
            {
                usbDev-> Read(USB_read, USB_BYTELENGTH);
                usbDev-> Read(USB_read2, USB_BYTELENGTH);
                usbDev-> Read(USB_read3, USB_BYTELENGTH);
                usbDev-> Read(USB_read4, USB_BYTELENGTH);
            }

    }
    //read init values
    i=1;
    if (Selected_PE5004 == PE5004_FIRST ) //col and row are switched and inverted chip-pins to orientation
    {
        usbDev-> Read(USB_read, USB_BYTELENGTH);
        for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++)
        {
            for (c=Value_COLEND-1;c>=(Value_COLSTART-1);c--)
                {
                Value_adreal[r][c]=USB_read[i]; //r c
                i++;
            }
        }
    }
    else
    {
        usbDev-> Read(USB_read, USB_BYTELENGTH);
        usbDev-> Read(USB_read2, USB_BYTELENGTH);
        usbDev-> Read(USB_read3, USB_BYTELENGTH);
        usbDev-> Read(USB_read4, USB_BYTELENGTH);

//        wxLogDebug("1 %i", USB_read[1]);wxLogDebug("2 %i", USB_read2[1]);
//        wxLogDebug("3 %i", USB_read[56]);wxLogDebug("4 %i", USB_read2[56]);
//        wxLogDebug("5 %i", USB_read3[1]);wxLogDebug("6 %i", USB_read4[1]);
//        wxLogDebug("7 %i", USB_read3[44]);wxLogDebug("8 %i", USB_read4[44]);


        for (c=(Value_COLSTART-1);c<Value_COLEND;c++)
            {
            for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++)
                {
                if (i<57) Value_adreal[r][c]= (((USB_read[i])<<4) | ((USB_read2[i])>>4)) ; //r c
                else Value_adreal[r][c]= (((USB_read3[i-56])<<4) | ((USB_read4[i-56])>>4)) ;
                i++;
            }
        }
    }

   // wxLogDebug("Conversion started");
    if (invert==false){
        for(int col =0; col< Value_COLEND; col++){
            for(int row =0; row< Value_ROWEND; row++){
                Value_admid[row][col]=(((Value_admid[row][col]*(filt-1))+Value_adreal[row][col])/filt);
                HELPVAL=(abs(Value_adcal[row][col]-Value_admid[row][col])-thresh);
                if (HELPVAL>0) Value_ADC[row][col]=((Value_admid[row][col]-Value_adcal[row][col])*stretch+Value_adcal[row][col]);
                else Value_ADC[row][col]=Value_adcal[row][col];
            }
            pbar[col]->Update_all(col, &Value_ROWEND, Value_ADC);
        }
    }else{
        if (Selected_PE5004 == PE5004_FIRST )
        {
            for(int col =0; col< Value_COLEND; col++){
                rowthresh[col]=0;
                for(int row =0; row< Value_ROWEND; row++){
                    HELPVAL=((Value_adcal[row][col]-Value_adreal[row][col])-thresh);
                    if (HELPVAL>0) {
                        Value_ADC[row][col]=(((Value_ADC[row][col]*(filt-1))+((HELPVAL)*stretch))/filt);
                    }
                    else {Value_ADC[row][col]=((Value_ADC[row][col]*(filt-1))/(filt*2));}
                    if (Value_ADC[row][col]>rowthresh[col]) rowthresh[col]=Value_ADC[row][col];
                }
               // rowthresh[col]>>=2;
               // for(int row =0; row< Value_ROWEND; row++) if (Value_ADC[row][col]<rowthresh[col]) Value_ADC[row][col]=0;
                pbar[col]->Update_all(col, &Value_ROWEND, Value_ADC);
            }
        }
        else{
             for(int row =0; row< Value_ROWEND; row++){
              //  rowthresh[row]=0;
                for(int col =0; col< Value_COLEND; col++){
                    HELPVAL=((Value_adcal[row][col]-Value_adreal[row][col])-thresh);
                    if (HELPVAL>0) {
                        Value_ADC[row][col]=(((Value_ADC[row][col]*(filt-1))+((HELPVAL)*stretch))/filt);
                    }
                    else {Value_ADC[row][col]=((Value_ADC[row][col]*(filt-1))/(filt*2));}
                    //if (Value_ADC[row][col]>rowthresh[row]) rowthresh[row]=Value_ADC[row][col];
                }
                //rowthresh[row]>>=2;
                //for(int col =0; col< Value_COLEND; col++) if (Value_ADC[row][col]<rowthresh[row]) Value_ADC[row][col]=0;
            }
            for(int col =0; col< Value_COLEND; col++)pbar[col]->Update_all(col, &Value_ROWEND, Value_ADC);
        }
    }

    pgrid->Update_all(&Value_COLEND, &Value_ROWEND, Value_ADC);
    pval->Update_all(&Value_COLEND, &Value_ROWEND, Value_ADC);
    ptouch->Update_all(&Value_COLEND, &Value_ROWEND, Value_ADC, boxmode_game, boxmode_oled);

    if (mode != true)pTimer->Start(Value_updaterate, mode);
}


void calibpanel::Update_all()
{
       // ch_COLSTART->
        Value_COLSTART = ch_COLSTART->GetSelection()+1;
        Value_ROWSTART = ch_ROWSTART->GetSelection()+1;
        Value_COLEND = ch_COLEND->GetSelection()+1;
        Value_ROWEND = ch_ROWEND->GetSelection()+1;
        (tf_WaitCOL->GetValue()).ToLong((long*)&Value_WaitCOL,10);
        (tf_WaitROW->GetValue()).ToLong((long*)&Value_WaitROW,10);
        Value_PWRI = ch_PWRI->GetSelection();
      //  Value_PWRP = ch_PWRP->GetSelection();
      //  Value_PWRS = ch_PWRS->GetSelection();
        Value_SINF = sl_SINF->GetValue();
        Value_SINA = sl_SINA->GetValue();
        Value_PCO = sl_PCO->GetValue();
        Value_DACREF = sl_DACREF->GetValue();
        Value_GCO = sl_GCO->GetValue();
        Value_updaterate = sl_updaterate->GetValue();
        (tf_thresh->GetValue()).ToLong((long*)&thresh,10);
        (tf_stretch->GetValue()).ToLong((long*)&stretch,10);
        (tf_filt->GetValue()).ToLong((long*)&filt,10);
        boxmode_game = cb_boxmode->GetValue();
        boxmode_oled = cb_boxmode1->GetValue();
        //multimode = true; //cb_multimode->GetValue();
}

//void calibpanel::On_Paddle( wxCommandEvent& event )
//{
//      boxmode = cb_boxmode->GetValue();
      //if (boxmode){
      //    multimode = true;
      //    //cb_multimode->SetValue(multimode);
      //}
//}

void calibpanel::On_OpenBargraph( wxCommandEvent& event )
{
      pbar[ch_bar->GetSelection()]->Show();
}

void calibpanel::On_OpenValuetable( wxCommandEvent& event )
{
      pval->Show();
}

void calibpanel::On_OpenValuegrid( wxCommandEvent& event )
{
      pgrid->Show();
}

void calibpanel::On_OpenTouch( wxCommandEvent& event )
{
      ptouch->Show();
}

void calibpanel::On_Connect( wxCommandEvent& event )
{
    DWORD vendorID = VENDOR_ID;
    DWORD productID = PRODUCT_ID;
    DWORD versionNumber = VERSION_NB;

    //connect USB device
    if(usbDev->IsConnected) {
        pUSB_write[12] = USB_OFF;  // USB Off
        pUSB_write[11] = Selected_PE5004;
        usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
        usbDev->Disconnect();
        SetConnectStatus(false);
        On_Stop(blankevent);



    } else {

        usbDev->Connect(&vendorID,&productID,&versionNumber);
        if(usbDev->IsConnected) {
            pUSB_write[12] = USB_ON;  // USB On
            pUSB_write[11] = Selected_PE5004;
            usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
            SetConnectStatus(true);
        } else {
            SetConnectStatus(false);
        }
    }
}

void calibpanel::SetConnectStatus(bool bConnected) {

    if(bConnected) {
        mbFileConnect->Check(true);
        toolBar->ToggleTool(ID_TOOL_CONNECT, true);
        toolBar->SetToolNormalBitmap(ID_TOOL_CONNECT, wxIcon("ICO_CONNECT_ON", wxBITMAP_TYPE_ICO_RESOURCE, 32, 32));
        statusBar->SetStatusText("EVA5004 Connected via USB", 0);
    } else {
        mbFileConnect->Check(false);
        toolBar->ToggleTool(ID_TOOL_CONNECT, false);
        toolBar->SetToolNormalBitmap(ID_TOOL_CONNECT, wxIcon("ICO_CONNECT_OFF", wxBITMAP_TYPE_ICO_RESOURCE, 32, 32));
        statusBar->SetStatusText("EVA5004 Disconnected", 0);
    }
}

void calibpanel::On_Calib( wxCommandEvent& event )
{
    int c;
    int r;
    int i;
   //connect USB device
    if(!usbDev->IsConnected) {
        wxMessageBox("Please connect EVA5004KIT !!!!", "alarm", wxICON_ERROR);
        return;
    }

    pUSB_write[0] = 0;
    pUSB_write[2] = Value_WaitCOL;
    pUSB_write[3] = Value_WaitROW;
    pUSB_write[4] = (Value_PWRI<<4)|(Value_PWRP<<2)|(Value_PWRS);
    pUSB_write[5] = Value_SINF;
    pUSB_write[6] = Value_SINA;
    pUSB_write[7] = (Value_GCO<<4)|Value_DACREF;
    pUSB_write[8] = Value_PCO;
    pUSB_write[9] = (Value_PCO>>8);
    //caution: GUI ROW correspond to PE5004 COL and GUI COL correspond to PE5004 ROW
    if (Selected_PE5004 == PE5004_FIRST ){
        if(cb_boxmode1->GetValue() == true) { //check if OLED selected
        pUSB_write[10] = 0xdd; //the EVABoard firmware dedect this as OLED selected
        pUSB_write[13] = 0x12;
        //pUSB_write[13] = ((Value_ROWSTART)<<4)|(10-Value_COLEND);
        }
        else{
        pUSB_write[10] = (Value_ROWEND<<4)|(9-Value_COLSTART);
        pUSB_write[13] = ((Value_ROWSTART)<<4)|(10-Value_COLEND);
        }
    }
    else {
        pUSB_write[10] = ((Value_COLEND-1)<<4)|(Value_ROWEND-1);
        pUSB_write[13] = ((Value_COLSTART-1)<<4)|(Value_ROWSTART-1);
    }
    pUSB_write[11] = Selected_PE5004;

    //write init values

    for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++)Value_adcal[row][col]=1024;

    for (int k=0; k<20; k++){
        //write init values
        pUSB_write[1] = usbDev->togglecurrent;
        usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
        Sleep(50);
        i=1;
        if (Selected_PE5004 == PE5004_FIRST )
        {
            usbDev-> Read(USB_read, USB_BYTELENGTH);
            for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++){
                for (c=Value_COLEND-1;c>=(Value_COLSTART-1);c--){
                    Value_adreal[r][c]=USB_read[i]; //r c
                    i++;
                }
            }
        }
        else{
            usbDev-> Read(USB_read, USB_BYTELENGTH);
            usbDev-> Read(USB_read2, USB_BYTELENGTH);
            usbDev-> Read(USB_read3, USB_BYTELENGTH);
            usbDev-> Read(USB_read4, USB_BYTELENGTH);
            for (c=(Value_COLSTART-1);c<Value_COLEND;c++)
                {
                for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++)
                    {
                    if (i<57) Value_adreal[r][c]= (((USB_read[i])<<4) | ((USB_read2[i])>>4)) ; //r c
                    else Value_adreal[r][c]= (((USB_read3[i-56])<<4) | ((USB_read4[i-56])>>4)) ;
                    i++;
                }
            }


        }
        for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++){
            if (Value_adcal[row][col]>Value_adreal[row][col])(Value_adcal[row][col]=Value_adreal[row][col]);
        }
    }
    invert=true;
}

void calibpanel::On_ClearCalib( wxCommandEvent& event )
{
     for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++)
        {
            Value_adcal[row][col]=0;
        }
     invert=false;
}

void calibpanel::On_Preset( wxCommandEvent& event )
{
    // load file
    int iResult;

    wxFileDialog *dialog = new wxFileDialog(this, "Load Preset Data", ".", strFileNameGlobal, "*.txt", wxFD_OPEN);
    iResult = dialog->ShowModal();
    strFileNameGlobal = dialog->GetPath();
    delete dialog;

    wxFileConfig *config = new wxFileConfig("EVA5004", "PE GmbH", strFileNameGlobal ,"", wxCONFIG_USE_LOCAL_FILE);

    config->Read("Value_COLSTART", &Value_COLSTART, 1);
    config->Read("Value_ROWSTART", &Value_ROWSTART, 1);
    config->Read("Value_COLEND", &Value_COLEND, 8);
    config->Read("Value_ROWEND", &Value_ROWEND, 7);
    config->Read("Value_SINF", &Value_SINF, 7);
    config->Read("Value_SINA", &Value_SINA, 62);
    config->Read("Value_PCO", &Value_PCO, 210);
    config->Read("Value_DACREF", &Value_DACREF, 15);
    config->Read("Value_GCO", &Value_GCO, 4);
    config->Read("thresh", &thresh, 0);
    config->Read("stretch", &stretch, 4);
    config->Read("filt", &filt, 2);
    config->Read("paddle", &boxmode_game, false);
    config->Read("calibrate", &calibrate, false);
    config->Read("OpenWindow", &openw, 0);
    config->Read("Autoconnect", &autoconnect, false);
    delete config;

    ch_COLSTART->SetSelection(Value_COLSTART-1);
    ch_ROWSTART->SetSelection(Value_ROWSTART-1);
    ch_COLEND->SetSelection(Value_COLEND-1);
    ch_ROWEND->SetSelection(Value_ROWEND-1);

    tf_SINF->SetValue(wxString::Format("%i", Value_SINF));
    tf_SINA->SetValue(wxString::Format("%i", Value_SINA));
    tf_PCO->SetValue(wxString::Format("%i", Value_PCO));
    tf_DACREF->SetValue(wxString::Format("%i", Value_DACREF));
    tf_GCO->SetValue(wxString::Format("%i", Value_GCO));
    tf_thresh->SetValue(wxString::Format("%i", thresh));
    tf_stretch->SetValue(wxString::Format("%i", stretch));
    tf_filt->SetValue(wxString::Format("%i", filt));

    sl_SINF->SetValue(Value_SINF);
    sl_SINA->SetValue(Value_SINA);
    sl_PCO->SetValue(Value_PCO);
    sl_DACREF->SetValue(Value_DACREF);
    sl_GCO->SetValue(Value_GCO);
    cb_boxmode->SetValue(boxmode_game);
    //cb_multimode->SetValue(multimode);
    if (autoconnect) if(!(usbDev->IsConnected)) On_Connect(blankevent);
    Update_all();
    Sleep(100);
    if (calibrate)On_Calib(blankevent);
    switch(openw){
        case 1: {pval->Show();On_Continous(blankevent);break;}
        case 2: {pgrid->Show();On_Continous(blankevent);break;}
        case 3: {ptouch->Show();On_Continous(blankevent);break;}
        default: break;
    }
}






void calibpanel::On_Save( wxCommandEvent& event )
{
    // load file
    int iResult;
    wxString strFileName;
    wxFile outFile;

    strFileName = wxDateTime::Now().Format("ConfigurationData_%Y%m%d_%H%M%S.txt");

    wxFileDialog *dialog = new wxFileDialog(this, "Save Configuration Data", ".", strFileName, "*.txt", wxFD_SAVE);
    iResult = dialog->ShowModal();
    strFileName = dialog->GetPath();
    strFileNameGlobal = strFileName;
    delete dialog;

    if(iResult == wxID_OK) {
        if(outFile.Exists(strFileName)) {
            iResult = wxMessageBox("File already exists. Overwrite file:\n" + strFileName, "Save Configuration Data", wxYES_NO | wxICON_QUESTION);
            if(iResult == wxYES) {
                if(!outFile.Access(strFileName, wxFile::write)) {
                    wxMessageBox("Could not write file:\n" + strFileName, "Save Configuration Data", wxOK | wxICON_ERROR);
                    return;
                }
            } else {
                return;
            }
        }
    } else {
        return;
    }

    Update_all();

    wxFileConfig *config = new wxFileConfig("EVA5004", "PE GmbH", strFileName ,"", wxCONFIG_USE_LOCAL_FILE);

    config->Write("Value_COLSTART", Value_COLSTART);
    config->Write("Value_ROWSTART", Value_ROWSTART);
    config->Write("Value_COLEND", Value_COLEND);
    config->Write("Value_ROWEND", Value_ROWEND);
    config->Write("Value_SINF", Value_SINF);
    config->Write("Value_SINA", Value_SINA);
    config->Write("Value_PCO", Value_PCO);
    config->Write("Value_DACREF", Value_DACREF);
    config->Write("Value_GCO", Value_GCO);
    config->Write("thresh", thresh);
    config->Write("stretch", stretch);
    config->Write("filt", filt);
    config->Write("paddle", boxmode_game);

    delete config;
}

void calibpanel::Scroll_calib( wxScrollEvent& event )
{
    switch(event.GetId())
    {
        case SINF:
        {
            Value_SINF = sl_SINF->GetValue();
            tf_SINF->SetValue(wxString::Format("%i", Value_SINF));
            break;
        }
        case SINA:
        {
            Value_SINA = sl_SINA->GetValue();
            tf_SINA->SetValue(wxString::Format("%i", Value_SINA));
            break;
        }
        case PCO:
        {
            Value_PCO = sl_PCO->GetValue();
            tf_PCO->SetValue(wxString::Format("%i", Value_PCO));
            break;
        }
         case DACREF:
        {
            Value_DACREF = sl_DACREF->GetValue();
            tf_DACREF->SetValue(wxString::Format("%i", Value_DACREF));
            break;
        }
        case GCO:
        {
            Value_GCO = sl_GCO->GetValue();
            tf_GCO->SetValue(wxString::Format("%i", Value_GCO));
            break;
        }
        case updaterate:
        {
            Value_updaterate = sl_updaterate->GetValue();
            tf_updaterate->SetValue(wxString::Format("%i", Value_updaterate));
        }
    }

}

void calibpanel::Text_calib( wxCommandEvent& event )
{
    switch(event.GetId())
    {
        case SINF:
        {
            (tf_SINF->GetValue()).ToLong((long*)&Value_SINF,10);
             sl_SINF->SetValue(Value_SINF);
             break;
        }
        case SINA:
        {
            (tf_SINA->GetValue()).ToLong((long*)&Value_SINA,10);
             sl_SINA->SetValue(Value_SINA);
             break;
        }
        case PCO:
        {
            (tf_PCO->GetValue()).ToLong((long*)&Value_PCO,10);
             sl_PCO->SetValue(Value_PCO);
             break;
        }
        case DACREF:
        {
            (tf_DACREF->GetValue()).ToLong((long*)&Value_DACREF,10);
             sl_DACREF->SetValue(Value_DACREF);
             break;
        }
        case GCO:
        {
            (tf_GCO->GetValue()).ToLong((long*)&Value_GCO,10);
             sl_GCO->SetValue(Value_GCO);
             break;
        }
        case updaterate:
        {
            (tf_updaterate->GetValue()).ToLong((long*)&Value_updaterate,10);
             sl_updaterate->SetValue(Value_updaterate);
        }
    }
}

void calibpanel::On_SingleShot( wxCommandEvent& event )
{

    if(!usbDev->IsConnected) {
        wxMessageBox("Please connect EVA5004KIT !!!!", "alarm", wxICON_ERROR);
        return;
    }
    mode=true;
    Update_all();
    pTimer->Start(Value_updaterate, mode);
}

void calibpanel::On_Continous( wxCommandEvent& event )
{
    if(!usbDev->IsConnected) {
        wxMessageBox("Please connect EVA5004KIT !!!!", "alarm", wxICON_ERROR);
        return;
    }
    mode=false;
    Update_all();
    pTimer->Start(Value_updaterate, mode);
    statusBar->SetStatusText("running", 1);
}

void calibpanel::On_Stop( wxCommandEvent& event )
{
    mode=true;
    pTimer->Stop();
    statusBar->SetStatusText("stopped", 1);
}

void calibpanel::OnSelectIC(wxCommandEvent &event) {

        DWORD vendorID = VENDOR_ID;
        DWORD productID = PRODUCT_ID;
        DWORD versionNumber = VERSION_NB;



    if(m_selicnbr->GetSelection() == 0) {

        ch_ROWSTART->Clear();
        ch_ROWSTART->Append("0");
        ch_ROWSTART->Append("1");
        ch_ROWSTART->Append("2");
        ch_ROWSTART->Append("3");
        ch_ROWSTART->Append("4");
        ch_ROWSTART->Append("5");
        ch_ROWSTART->Append("6");

        ch_ROWSTART->Select(0);


        ch_ROWEND->Clear();
        ch_ROWEND->Append("0");
        ch_ROWEND->Append("1");
        ch_ROWEND->Append("2");
        ch_ROWEND->Append("3");
        ch_ROWEND->Append("4");
        ch_ROWEND->Append("5");
        ch_ROWEND->Append("6");

        ch_ROWEND->Select(6);


        ch_COLSTART->Clear();

        ch_COLSTART->Append("0");
        ch_COLSTART->Append("1");
        ch_COLSTART->Append("2");
        ch_COLSTART->Append("3");
        ch_COLSTART->Append("4");
        ch_COLSTART->Append("5");
        ch_COLSTART->Append("6");
        ch_COLSTART->Append("7");


        ch_COLSTART->Select(0);


        ch_COLEND->Clear();
        ch_COLEND->Append("0");
        ch_COLEND->Append("1");
        ch_COLEND->Append("2");
        ch_COLEND->Append("3");
        ch_COLEND->Append("4");
        ch_COLEND->Append("5");
        ch_COLEND->Append("6");
        ch_COLEND->Append("7");

        ch_COLEND->Select(7);

        //ch_COLEND->Append();
        //int Append(const wxString& item)
        //Adds the item to the end of the list box.

        On_Stop(blankevent);

        pUSB_write[12] = USB_OFF;  // USB Off
        pUSB_write[11] = Selected_PE5004;
        usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
        usbDev->Disconnect();
        SetConnectStatus(false);

        Sleep(200);

        Selected_PE5004 = PE5004_FIRST;
        wxLogDebug("chip1");

        usbDev->Connect(&vendorID,&productID,&versionNumber);
        if(usbDev->IsConnected) {
            pUSB_write[12] = USB_ON;  // USB On
            pUSB_write[11] = Selected_PE5004;
            usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
            SetConnectStatus(true);
        } else {
            SetConnectStatus(false);
        }


    } else {
        On_Stop(blankevent);

        pUSB_write[12] = USB_OFF;  // USB Off
        pUSB_write[11] = Selected_PE5004;
        usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
        usbDev->Disconnect();
        SetConnectStatus(false);

        cb_boxmode1->SetValue(false);

        ch_ROWSTART->Clear();
        ch_ROWSTART->Append("0");
        ch_ROWSTART->Append("1");
        ch_ROWSTART->Append("2");
        ch_ROWSTART->Append("3");
        ch_ROWSTART->Append("4");
        ch_ROWSTART->Append("5");
        ch_ROWSTART->Append("6");
        ch_ROWSTART->Append("7");
        ch_ROWSTART->Append("8");
        ch_ROWSTART->Append("9");


        ch_ROWSTART->Select(0);

        ch_ROWEND->Clear();
        ch_ROWEND->Append("0");
        ch_ROWEND->Append("1");
        ch_ROWEND->Append("2");
        ch_ROWEND->Append("3");
        ch_ROWEND->Append("4");
        ch_ROWEND->Append("5");
        ch_ROWEND->Append("6");
        ch_ROWEND->Append("7");
        ch_ROWEND->Append("8");
        ch_ROWEND->Append("9");


        ch_ROWEND->Select(9);

        ch_COLSTART->Clear();
        ch_COLSTART->Append("0");
        ch_COLSTART->Append("1");
        ch_COLSTART->Append("2");
        ch_COLSTART->Append("3");
        ch_COLSTART->Append("4");
        ch_COLSTART->Append("5");
        ch_COLSTART->Append("6");
        ch_COLSTART->Append("7");
        ch_COLSTART->Append("8");
        ch_COLSTART->Append("9");


        ch_COLSTART->Select(0);

        ch_COLEND->Clear();
        ch_COLEND->Append("0");
        ch_COLEND->Append("1");
        ch_COLEND->Append("2");
        ch_COLEND->Append("3");
        ch_COLEND->Append("4");
        ch_COLEND->Append("5");
        ch_COLEND->Append("6");
        ch_COLEND->Append("7");
        ch_COLEND->Append("8");
        ch_COLEND->Append("9");

        ch_COLEND->Select(9);

        Sleep(200);

        Selected_PE5004 = PE5004_SECOND;
        wxLogDebug("chip2");

        usbDev->Connect(&vendorID,&productID,&versionNumber);
        if(usbDev->IsConnected) {
            pUSB_write[12] = USB_ON;  // USB On
            pUSB_write[11] = Selected_PE5004;
            usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
            SetConnectStatus(true);
        } else {
            SetConnectStatus(false);
        }

    }

}

void calibpanel::On_Oled( wxCommandEvent& event )
{
    if(cb_boxmode1->GetValue() == true) {
       m_selicnbr->Select(0);
        ch_ROWSTART->Clear();
        ch_ROWSTART->Append("1");
        ch_ROWSTART->Select(0);
        ch_ROWEND->Clear();
        ch_ROWEND->Append("1");
        ch_ROWEND->Select(0);
        ch_COLSTART->Clear();
        ch_COLSTART->Append("1");
        ch_COLSTART->Append("2");
        ch_COLSTART->Select(0);
        ch_COLEND->Clear();
        ch_COLEND->Append("1");
        ch_COLEND->Append("2");
        ch_COLEND->Select(1);
    }
}

void calibpanel::On_searchPCO( wxCommandEvent& event )
{
    int c;
    int r;
    int i;
    int tune;
    int col_cal;
    int row_cal;
    int max_cal;
    int PCO_cal;
    bool calib_done;
    col_cal= Value_COLSTART-1+abs(( Value_COLEND-Value_COLSTART)/2);
    row_cal= Value_ROWSTART-1+abs(( Value_ROWEND-Value_ROWSTART)/2);
    wxLogDebug("col row %i %i", row_cal,col_cal);
    Update_all();
    statusBar->SetStatusText("searching optimum PCO", 1);
    pUSB_write[0] = 0;
    pUSB_write[1] = usbDev->togglecurrent;
    pUSB_write[2] = Value_WaitCOL;
    pUSB_write[3] = Value_WaitROW;
    pUSB_write[4] = (Value_PWRI<<4)|(Value_PWRP<<2)|(Value_PWRS);
    pUSB_write[5] = Value_SINF;
    pUSB_write[6] = Value_SINA;
    pUSB_write[7] = (Value_GCO<<4)|Value_DACREF;

    if (Selected_PE5004 == PE5004_FIRST ){
        if(cb_boxmode1->GetValue() == true) { //check if OLED selected
        pUSB_write[10] = 0xdd; //the EVABoard firmware dedect this as OLED selected
        pUSB_write[13] = 0x12;
        //pUSB_write[13] = ((Value_ROWSTART)<<4)|(10-Value_COLEND);
        }
        else{
        pUSB_write[10] = (Value_ROWEND<<4)|(9-Value_COLSTART);
        pUSB_write[13] = ((Value_ROWSTART)<<4)|(10-Value_COLEND);


        }
    }
    else {
        pUSB_write[10] = ((Value_COLEND-1)<<4)|(Value_ROWEND-1);
        pUSB_write[13] = ((Value_COLSTART-1)<<4)|(Value_ROWSTART-1);
    }
    pUSB_write[11] = Selected_PE5004;



    //write init values
    Value_PCO=30;
    calib_done=0;
    max_cal=0;
    PCO_cal=30;
    for (int t=0; t<2;t++){

        pUSB_write[8] = Value_PCO;
        pUSB_write[9] = (Value_PCO>>8);
        pUSB_write[1] = usbDev->togglecurrent;
        usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
        Sleep(200);
        if (Selected_PE5004 == PE5004_FIRST ){ //col and row are switched and inverted chip-pins to orientation
                usbDev-> Read(USB_read, USB_BYTELENGTH);}
            else
            {
                usbDev-> Read(USB_read, USB_BYTELENGTH);
                usbDev-> Read(USB_read2, USB_BYTELENGTH);
                usbDev-> Read(USB_read3, USB_BYTELENGTH);
                usbDev-> Read(USB_read4, USB_BYTELENGTH);
            }

        if (t==0){tune=16;filt=1;statusBar->SetStatusText("searching optimum PCO coarse", 1);}
        else {tune=1;filt=5;statusBar->SetStatusText("searching optimum PCO fine", 1);}
        while(!calib_done){
        pUSB_write[8] = Value_PCO;
        pUSB_write[9] = (Value_PCO>>8);
        for (int k=0; k<=filt; k++){
            //write init values
            pUSB_write[1] = usbDev->togglecurrent;
            usbDev->Write(pUSB_write, USB_WRBYTELENGTH);
            i=1;
            if (Selected_PE5004 == PE5004_FIRST ) //col and row are switched and inverted chip-pins to orientation
            {
                usbDev-> Read(USB_read, USB_BYTELENGTH);
                for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++)
                {
                    for (c=Value_COLEND-1;c>=(Value_COLSTART-1);c--)
                        {
                        Value_adreal[r][c]=USB_read[i]; //r c
                        i++;
                    }
                }
            }
            else
            {
                usbDev-> Read(USB_read, USB_BYTELENGTH);
                usbDev-> Read(USB_read2, USB_BYTELENGTH);
                usbDev-> Read(USB_read3, USB_BYTELENGTH);
                usbDev-> Read(USB_read4, USB_BYTELENGTH);

//                wxLogDebug("1 %i", USB_read[1]);wxLogDebug("2 %i", USB_read2[1]);
//                wxLogDebug("3 %i", USB_read[56]);wxLogDebug("4 %i", USB_read2[56]);
//                wxLogDebug("5 %i", USB_read3[1]);wxLogDebug("6 %i", USB_read4[1]);
//                wxLogDebug("7 %i", USB_read3[44]);wxLogDebug("8 %i", USB_read4[44]);


                for (c=(Value_COLSTART-1);c<Value_COLEND;c++)
                    {
                    for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++)
                        {
                        if (i<57) Value_adreal[r][c]= (((USB_read[i])<<4) | ((USB_read2[i])>>4)) ; //r c
                        else Value_adreal[r][c]= (((USB_read3[i-56])<<4) | ((USB_read4[i-56])>>4)) ;
                        i++;
                    }
                }
            }


            for(int col =0; col< Value_COLEND; col++){
                for(int row =0; row< Value_ROWEND; row++){
                    Value_admid[row][col]=(((Value_admid[row][col]*(filt-1))+Value_adreal[row][col])/filt);
                }
            }
        }
        wxLogDebug("mid %i", Value_admid[row_cal][col_cal]);
        wxLogDebug("col %i", col_cal);
        wxLogDebug("row %i", row_cal);
        pgrid->Update_all(&Value_COLEND, &Value_ROWEND, Value_admid);
        pval->Update_all(&Value_COLEND, &Value_ROWEND, Value_admid);
        if (Value_admid[row_cal][col_cal]>max_cal) {
            max_cal=Value_admid[row_cal][col_cal];
            PCO_cal=Value_PCO;
        }
        wxLogDebug("maxcal %i", max_cal);
        if (Value_admid[row_cal][col_cal]< (max_cal-(25/filt)))calib_done=1;

        else Value_PCO+=tune;

        if (Value_PCO>1024){calib_done=1;statusBar->SetStatusText("PCO failed", 1);}
        sl_PCO->SetValue(Value_PCO);
        tf_PCO->SetValue(wxString::Format("%i", Value_PCO));Update();
        wxLogDebug("pco %i", Value_PCO);
        }
        calib_done=0;
        max_cal=0;
        Value_PCO=PCO_cal-10;
        sl_PCO->SetValue(Value_PCO);
        tf_PCO->SetValue(wxString::Format("%i", Value_PCO));
    }
    Value_PCO=PCO_cal;
    sl_PCO->SetValue(Value_PCO);
    tf_PCO->SetValue(wxString::Format("%i", Value_PCO));
    statusBar->SetStatusText("searching PCO succeeded", 1);



}




calibpanel::~calibpanel()
{
    Disconnect(wxEVT_TIMER, wxCommandEventHandler(calibpanel::OnTimer));
    wxDELETE(pTimer);
}


