
#include "wx/wx.h"
#pragma once

#include <windows.h>
// USB and PE5004 organisation
#define USB_BYTELENGTH  58

/* Both of these functions return INVALID_HANDLE_VALUE on an error, if there is no error
    then the HANDLE must be closed using 'CloseHandle' */

class CUSBDevice
{
public:
	CUSBDevice();
	/* Connects to the USB HID described by the combination of vendor id, product id
	   If the attribute is null, it will connect to first device satisfying the remaining
	   attributes. */
	CUSBDevice(const DWORD *vendorID, const DWORD *productID, const DWORD *versionNumber);
	~CUSBDevice();
	bool Connect(const DWORD *vendorID, const DWORD *productID, const DWORD *versionNumber);
    void Disconnect();
	bool Write(const BYTE *bytes, int nBuffLen);
	int Read(BYTE *bytes, int nBuffLen);
    //void Execute_Conversion(int adc[10][10]);
    void Execute_Conversion2();
    void Execute_Conversion1();
    bool IsConnected;
    int togglenext, togglecurrent;

#ifdef _DEBUG
	void ExploreToDebugWindow();	// just enumerates the devices and displays vid, pid, ver in the debugger window.
#endif

protected:
	HANDLE ConnectToIthDevice (DWORD i);	/* Connects to the ith USB HID device connected to the computer */
private:
	HANDLE handle;
	HANDLE EventObject;
	OVERLAPPED HIDOverlapped;


};
